/*
 * Term.java
 *
 * George Ferguson, ferguson@cs.rochester.edu, 20 Aug 2002
 * Time-stamp: <Mon Mar 10 13:49:38 EST 2003 ferguson>
 */

import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.NoSuchElementException;

public class Term {
    String functor;
    LispList args;
    // constant c
    public Term(String c) {
	this.functor = c;
	this.args = new LispList();
    }
    // f(a, b, c, ...)
    public Term(String f, LispList args) {
	this.functor = f;
	this.args = args;
    }
    // a f b
    public Term(String f, Term arg1, Term arg2) {
	this.functor = f;
	this.args = new LispList();
	this.args.add(arg1);
	this.args.add(arg2);
    }
    // f a
    public Term(String f, Term arg1) {
	this.functor = f;
	this.args = new LispList();
	this.args.add(arg1);
    }
    public String toString() {
	if (args.isEmpty()) {
	    return functor;
	} else {
	    StringBuffer str = new StringBuffer("(");
	    str.append(functor);
	    ListIterator li = args.listIterator();
	    try {
		while (li.hasNext()) {
		    str.append(" ");
		    str.append(li.next().toString());
		}
	    } catch (NoSuchElementException ex) {
	    }
	    str.append(")");
	    return str.toString();
	}
    }
}
